/**
 * @file main.c
 * @author Boris Stefanovic, Joey Martig
 * @brief Main du programme de simulation de charges électriques et lignes de champs.
 * @date 23.05.2022
 */

#include <stdlib.h>
#include "field.h"


#define NCHARGES 2
#define NC 3
#define DX 25
#define NLINES 50


void main_old() {
	charge_t charges[NCHARGES] = {
			charge_create(0.25, vec2_create(0.25, 0.5)),
			charge_create(-0.25, vec2_create(0.75, 0.5))
	};
	struct gfx_context_t *ctxt = gfx_create("elec", WID, HEI);

	draw_everything(ctxt, charges, NCHARGES, NLINES, DX, 0.0, 1.0, 0.0, 1.0);
	gfx_present(ctxt);

	while (gfx_keypressed() != SDLK_ESCAPE);
	gfx_destroy(ctxt);
}


void main_new() {
	charge_t charges[NC];
	for (int i = 0; i < NC; ++i)
		charges[i] = charge_create(i % 2 == 0 ? rand_one() : -rand_one(), vec2_create(rand_one(), rand_one()));
	struct gfx_context_t *ctxt = gfx_create("elec", WID, HEI);

	draw_everything(ctxt, charges, NC, NLINES, DX, 0.0, 1.0, 0.0, 1.0);
	gfx_present(ctxt);
	while (gfx_keypressed() != SDLK_ESCAPE) {
		gfx_present(ctxt);
	}
	gfx_destroy(ctxt);
}


int main() {
	main_new();
	return EXIT_SUCCESS;
}
